diff -Naur nagios/cgi/cgiauth.c nagios-3.0.3.certauth/cgi/cgiauth.c
--- nagios/cgi/cgiauth.c	2008-03-31 21:09:33.000000000 +0200
+++ nagios-3.0.3.certauth/cgi/cgiauth.c	2008-07-17 16:11:29.000000000 +0200
@@ -35,6 +35,7 @@
 extern servicegroup    *servicegroup_list;
 
 extern int             use_authentication;
+extern int             use_ssl_authentication;
 
 
 
@@ -58,7 +59,12 @@
 	authinfo->authorized_for_configuration_information=FALSE;
 
 	/* grab username from the environment... */
-	temp_ptr=getenv("REMOTE_USER");
+	if(use_ssl_authentication) {
+		temp_ptr=getenv("SSL_CLIENT_S_DN_CN");
+		}
+	else{
+		temp_ptr=getenv("REMOTE_USER");
+		}
 	if(temp_ptr==NULL){
 		authinfo->username="";
 		authinfo->authenticated=FALSE;
diff -Naur nagios/cgi/cgiutils.c nagios-3.0.3.certauth/cgi/cgiutils.c
--- nagios/cgi/cgiutils.c	2008-06-23 22:47:44.000000000 +0200
+++ nagios-3.0.3.certauth/cgi/cgiutils.c	2008-07-17 15:15:34.000000000 +0200
@@ -108,6 +108,8 @@
 
 int             escape_html_tags=FALSE;
 
+int             use_ssl_authentication=FALSE;
+
 int             default_statusmap_layout_method=0;
 int             default_statuswrl_layout_method=0;
 
@@ -405,6 +407,9 @@
 
 		else if(!strcmp(var,"lock_author_names"))
 			lock_author_names=(atoi(val)>0)?TRUE:FALSE;
+
+		else if(!strcmp(var,"use_ssl_authentication"))
+			use_ssl_authentication=(atoi(val)>0)?TRUE:FALSE;
  	        }
 
 	/* free memory and close the file */
diff -Naur nagios/cgi/statuswml.c nagios-3.0.3.certauth/cgi/statuswml.c
--- nagios/cgi/statuswml.c	2008-05-19 20:42:28.000000000 +0200
+++ nagios-3.0.3.certauth/cgi/statuswml.c	2008-07-17 16:04:29.000000000 +0200
@@ -40,6 +40,7 @@
 extern hoststatus *hoststatus_list;
 extern servicestatus *servicestatus_list;
 
+extern int	use_ssl_authentication;
 extern int      enable_notifications;
 extern int      execute_service_checks;
 extern int      nagios_process_state;
@@ -961,7 +962,7 @@
 
 	printf("<p align='center' mode='wrap'>\n");
 	printf("<b>Your Name:</b><br/>\n");
-	printf("<input name='name' value='%s' /><br/>\n",getenv("REMOTE_USER"));
+	printf("<input name='name' value='%s' /><br/>\n",((use_ssl_authentication)?(getenv("SSL_CLIENT_S_DN_CN")):(getenv("REMOTE_USER"))));
 	printf("<b>Comment:</b><br/>\n");
 	printf("<input name='comment' value='acknowledged by WAP'/>\n");
 
@@ -1167,7 +1168,7 @@
 
 	printf("<p align='center' mode='wrap'>\n");
 	printf("<b>Your Name:</b><br/>\n");
-	printf("<input name='name' value='%s' /><br/>\n",getenv("REMOTE_USER"));
+	printf("<input name='name' value='%s' /><br/>\n",((use_ssl_authentication)?(getenv("SSL_CLIENT_S_DN_CN")):(getenv("REMOTE_USER"))));
 	printf("<b>Comment:</b><br/>\n");
 	printf("<input name='comment' value='acknowledged by WAP'/>\n");
 
